# FreeMonoidBase< Self > Struct Template Reference
[Algebra, Freemonoid]

Structural element for free monoid. More...

Inheritance diagram for FreeMonoidBase< Self >:
[legend]

List of all members.

## Public Types

typedef virtual_types< Self > ::alphabet_t | alphabet_t
| The type of the alphabet A.
typedef alphabet_t::letter_t | letter_t
| The type of letter hold by the alphabet.
typedef Self | self_t
| Exact type of the most derived type in the hierarchy.

## Public Member Functions

alphabet_t & | alphabet ()
| Alphabet's accessor.
const alphabet_t & | alphabet () const
| Alphabet's const accessor.
template<typename T >
Element< Self, T > | identity (SELECTOR(T)) const
| Returns the identity of the monoid (if mul_kind).
template<typename T >
Element< Self, T > | zero (SELECTOR(T)) const
| Returns the zero of the monoid (if add_kind).
bool | contains (const Element< Self, T > &elt) const
| Check if a given element is compatible with the structural element.
bool | contains (const Element< OtherS, T > &other) const
| Specialization of `contains` that always returns false.
bool | contains (const T &elt_value) const
| Check if an anonymous value is compatible with a structural element.
Element< Self, T > | choose (SELECTOR(T)) const
| Choose randomly an element in the structure.
self_t & | self ()
| Accessor to the real type.
const self_t & | self () const
| Accessor to the real type.

## Protected Member Functions

| FreeMonoidBase ()
| Default constructor accessor.
| FreeMonoidBase (const FreeMonoidBase &m)
| Copy constructor accessor.

## Detailed Description

### template<class Self>
struct vcsn::algebra::FreeMonoidBase< Self >

Structural element for free monoid.

`FreeMonoidBase` is the mother class of free monoids. A free monoid A* is a monoid generated by an alphabet A and which provides a way of iterating through letters of words.

Definition at line 46 of file freemonoid_base.hh.

## Member Function Documentation

bool contains | ( | const Element< OtherS, T > & | other | ) | const`[inherited]`

Specialization of `contains` that always returns false.

Indeed, elements structured by a particular type are always incompatible with structural elements of another type.

self_t& self | ( |  | ) | `[inherited]`

Accessor to the real type.

To be used by implementations in this class and derived structures to obtain a reference to the structural element with its most derived type.

const self_t& self | ( |  | ) | const`[inherited]`

Accessor to the real type.

To be used by implementations in this class and derived structures to obtain a reference to the structural element with its most derived type.